<!DOCTYPE html>
<html>
  <head>
    <meta charset="utf-8" />
    <title>Blockly to Pluto</title>
    <link
      rel="stylesheet"
      href="https://cdnjs.cloudflare.com/ajax/libs/font-awesome/4.7.0/css/font-awesome.min.css"
    />
    <script>
      const storageKey = "blockly-pluto-storage-key";
      async function ExtractAndDownload() {
        const content = document.getElementById("content").innerText;
        if(content == ""){
          alert("Something went wrong. Please try again.");
          return;
        }
        // saving file with name and location
        try {
          const handle = await window.showSaveFilePicker({
            suggestedName: "my_procedure",
            types: [
              {
                description: "Pluto script file",
                accept: { "text/plain": [".pluto"] },
              },
            ],
          });
          const writable = await handle.createWritable();
          await writable.write(content);
          await writable.close();
          alert("File saved successfully");
        } catch (err) {
          if(err.name==="AbortError"){
            return
          }
          console.log("Saving failed! Trying other method",err.name);

          const Filename = prompt("Enter file name: ");
          if (Filename) {
            var blob = new Blob([content], {
              type: "text/plain",
            });
            var link = document.createElement("a");
            link.href = URL.createObjectURL(blob);
            link.download = `${Filename}.pluto`;
            document.body.appendChild(link);
            link.click();
            document.body.removeChild(link);
            URL.revokeObjectURL(link.href);
          }
        }

      }
      function NewProject() {
        const data = window.localStorage?.getItem(storageKey);
        if (!data) {
          alert("Something went wrong. Please try again.");
          return;
        }
        window.localStorage?.removeItem(storageKey);
        window.location.reload();
      }

      async function SaveProject() {
        const data = window.localStorage?.getItem(storageKey);
        if (!data) {
          alert("Something went wrong. Please try again.");
          return;
        }
        // saving file with name and location
        try {
          const handle = await window.showSaveFilePicker({
            suggestedName: "my_project",
            types: [
              {
                description: "Pluto project file",
                accept: { "text/plain": [".plutoprj"] },
              },
            ],
          });
          const writable = await handle.createWritable();
          await writable.write(data);
          await writable.close();
          alert("File saved successfully");
        } catch (err) {
          if(err.name==="AbortError"){
            return
          }
          console.log("Saving failed! Trying other method", err.message);
          const Filename = prompt("Enter file name: ");
          if (Filename) {
            var blob = new Blob([data], {
              type: "text/plain",
            });
            var link = document.createElement("a");
            link.href = URL.createObjectURL(blob);
            link.download = `${Filename}.plutoprj`;
            document.body.appendChild(link);
            link.click();
            document.body.removeChild(link);
            URL.revokeObjectURL(link.href);
          }
        }
      }
      function LoadProject() {
        const fileInput = document.createElement("input");
        fileInput.type = "file";
        fileInput.accept = ".plutoprj";
        fileInput.style.display = "none";

        fileInput.onchange = function (event) {
          const file = event.target.files[0];
          if (file) {
            const reader = new FileReader();
            reader.onload = function (e) {
              try {
                const content = e.target.result;
                const jsonContent = JSON.parse(content);
                if (jsonContent && typeof jsonContent === "object") {
                  // saving in local storage
                  window.localStorage?.setItem(
                    storageKey,
                    JSON.stringify(jsonContent)
                  );
                  window.location.reload();
                  alert("Project loaded successfully.");
                } else {
                  throw "corrupt file";
                }
              } catch (error) {
                alert(
                  "Error parsing! Please make sure the file is a valid .plutoprj file."
                );
              }
            };
            reader.readAsText(file);
          }
        };

        document.body.appendChild(fileInput);
        fileInput.click();
        document.body.removeChild(fileInput);
      }
    </script>
  </head>
  <body>
    <div class="topnav" id="myTopnav">
      <h2 class="heading">Blockly to Pluto</h2>
      <div class="dropdown">
        <button class="button-4">
          Project <i class="fa fa-caret-down"></i>
        </button>
        <div class="dropdown-content">
          <button onclick="NewProject()">New Project</button>
          <button onclick="SaveProject()">Save Project</button>
          <button onclick="LoadProject()">Load Project</button>
        </div>
      </div>
      <button class="button-3" role="button" onclick="ExtractAndDownload()">
        Download Script
        <i class="fa fa-download" aria-hidden="true"></i>
      </button>
    </div>
    <div class="mainBox">
      <div id="blocklyDiv"></div>
      <div id="pageContainer">
        <div id="outputPane">
          <pre id="generatedCode"><code id="content"></code></pre>
          <div id="output"></div>
        </div>
      </div>
    </div>
  </body>
</html>
